#pragma once
#include <cstddef>

namespace framework
{
	namespace detail
	{
		class null_ptr {};

		struct ptr_inner
		{
			void* object;
			uintptr_t count;
		public:
			ptr_inner() : object(nullptr), count(0) {}
			virtual ~ptr_inner() {}
		public:
			void Inc() { count++; }
			void Dec() { if ((count == 0) || (--count == 0)) delete this; }
		};

		template<class T> struct general_inner : public ptr_inner
		{
			T deleter;
		public:
			general_inner(T& del) : deleter(del) {}
			virtual ~general_inner() { deleter(object); }
		};

		template<class T> void func_ptr_delete(void* p) { delete static_cast<T*>(p); }
		template<class T> void func_array_delete(void* p) { delete[] static_cast<T*>(p); }
		void func_ptr_static(void* p) {}
	}
}