#pragma once
#include <cstddef>
#include <exception>

#include "ptr_detail.hpp"
#include "../smart_ptr.hpp"

namespace framework
{
	// ǗĂIuWFNg܂B
	template<class T> void smart_ptr<T>::Free()
	{
		if (_inner) { _inner->Dec(); _inner = nullptr; }
	}

	// ǗĂIuWFNgL܂B
	template<class T> void smart_ptr<T>::Copy(const smart_ptr<T>& from)
	{
		if (_inner != from._inner)
		{
			this->Free();
			if (from._inner)
			{
				_inner = from._inner;
				_inner->Inc();
			}
		}
	}

	// IuWFNgւ܂B
	template<class T> void smart_ptr<T>::Swap(smart_ptr<T>& swp)
	{
		detail::ptr_inner* temp = _inner;
		_inner = swp._inner;
		swp._inner = temp;
	}

	// CX^XɐVIuWFNgݒ肵܂B
	template<class T> template<class U, class D> void smart_ptr<T>::Reset(U* object, D deleter)
	{
		this->Free();
		if (object)
		{
			try
			{
				_inner = new detail::general_inner<D>(deleter);
			} catch (std::exception& ex) { deleter(object); throw ex; }
			_inner->object = object;
			_inner->Inc();
		}
	}

	// IuWFNgLXg܂B
	template<class U, class V> smart_ptr<U> ptr_cast(const smart_ptr<V>& obj)
	{	
		smart_ptr<U> ptr;
		if (static_cast<U*>(obj.Get())) 
		{
			ptr._inner = obj._inner;
			ptr._inner->Inc();
		}
		return ptr;
	}
}